X-Git-Url: https://git.madduck.net/code/vcsh.git/blobdiff_plain/45d958ca5f802a6ca99b910186b82608af82e8c9..ab60947be1d3050fbdd22b0226e294d5361e2f9f:/vcsh

diff --git a/vcsh b/vcsh
index 1d4233d..4732e46 100755
--- a/vcsh
+++ b/vcsh
@@ -1,11 +1,21 @@
 #!/bin/sh
 
-[ -n "$VCSH_DEBUG" ]      && set -x
-[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
-[ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
+# This program is licensed under the GNU GPL version 2 or later.
+# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011
+# For details, see LICENSE. To submit patches, you have to agree to
+# license your code under the GNU GPL version 2 or later.
 
-SELF=$(basename $0)
 
+[ -n "$VCSH_DEBUG" ]                  && set -vx
+[ -z "$XDG_CONFIG_HOME" ]             && XDG_CONFIG_HOME="$HOME/.config"
+[ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
+[ -n "$VCSH_DEBUG" ]                  && set -vx
+[ -z "$VCSH_REPO_D" ]                 && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
+[ -z "$VCSH_HOOK_D" ]                 && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
+[ -z "$VCSH_BASE" ]                   && VCSH_BASE="$HOME"
+[ -z "$VCSH_GITIGNORE" ]              && VCSH_GITIGNORE='exact'
+
+SELF=$(basename $0)
 
 help() {
 	echo "usage: $SELF <args>
@@ -14,19 +24,22 @@ help() {
          [<repo>]       Clone from an existing repository
    help                 Display this help text
    delete               Delete an existing repository
+   enter                Enter repository; spawn new instance of \$SHELL
    init <repo>          Initialize a new repository
-   list                 List all repos
+   list                 List all repositories
+   list-tracked         List all files tracked by vcsh
+   list-tracked-by \\
+        <repo>          List files tracked by a repository
+   rename <repo> \\
+          <newname>     Rename repository
    run <repo> \\
        <command>        Use this repository
+   setup                Set up repository with recommended settings
+   write-gitignore \\
+   <repo>               Write .gitignore.d/<repo> via git ls-files
 
-   seed-gitignore \\
-   <repo>               Seed .gitignore.d/<repo> from git ls-files
-
-   <repo> <git command> Special command that allows you to run git commands
-                        directly without having to type so much ;)" >&2
-#   use <repo>     Use this repository
-#
-#   exit              Exit vcsh mode" >&2
+   <repo> <git command> Shortcut to run git commands directly
+   <repo>               Shortcut to enter repository" >&2
 }
 
 debug() {
@@ -37,122 +50,44 @@ verbose() {
 	if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
-use() {
-	verbose "use() begin"
-	if [ ! -d "$GIT_DIR" ]; then
-		echo E: no repository found for "$VCSH_REPO_NAME" >&2
-		return 1
-	fi
-	export GIT_DIR
-	export GIT_WORK_TREE="$(git config --get core.worktree)"
-	export VCSH_DIRECTORY="$VCSH_REPO_NAME"
-	verbose "use() end"
+fatal() {
+	echo "$SELF: fatal: $1" >&2
+	exit $2
 }
 
-init() {
-	verbose "init() begin"
-	[ -e "$GIT_DIR" ] &&
-		echo "$SELF: fatal: $GIT_DIR exists" &&
-		return 21
-	export GIT_WORK_TREE="$HOME"
-	mkdir -p "$GIT_WORK_TREE"
-	cd "$GIT_WORK_TREE" ||
-		(echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-		 exit 20) || exit 20
-	cd "$GIT_WORK_TREE"
-	git init
-	git config core.worktree     "$GIT_WORK_TREE"
-	git config core.excludesfile ".gitignore.d/$REPO_NAME"
-	touch   "$HOME/.gitignore.d/$REPO_NAME"
-	git add "$HOME/.gitignore.d/$REPO_NAME"
-	verbose "init() end"
+error() {
+	echo "$SELF: error: $1" >&2
 }
 
-leave() {
-	unset GIT_DIR
-	unset GIT_WORK_TREE
-	unset VCSH_DIRECTORY
+info() {
+	echo "$SELF: info: $1"
 }
 
-
-if [ "$1" = 'clone' ]; then
-	GIT_REMOTE="$2"
-	export GIT_REMOTE
-	VCSH_REPO_NAME="$3"
-	[ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
-	export VCSH_REPO_NAME
-	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'delete' ] ||
-     [ "$1" = 'init' ] ||
-     [ "$1" = 'run' ] ||
-     [ "$1" = 'seed-gitignore' ]; then
-	[ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
-	export VCSH_COMMAND="$1"
-	export VCSH_REPO_NAME="$2"
-	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-	shift 2
-	export VCSH_EXTERNAL_COMMAND="$*"
-	if [ "$VCSH_COMMAND" = 'run' ]; then
-		[ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
-	fi
-elif [ "$1" = 'help' ] ||
-     [ "$1" = 'list' ]; then
-	export VCSH_COMMAND="$1"
-else
-	[ -z $1 ] && help && return 0
-	export VCSH_COMMAND='run'
-	export VCSH_REPO_NAME="$1"
-	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-	[ -d $GIT_DIR ] || (help && return 1) || return 0
-	shift 1
-	export VCSH_EXTERNAL_COMMAND="git $*"
-fi
-
-
-for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
-do
-	if [ ! -d "$check_directory" ]; then
-		if [ -e "$check_directory" ]; then
-			echo "$SELF: error: $check_directory exists but is not a directory" >&2
-			exit 2
-		else
-			echo "$SELF: info: attempting to create $check_directory"
-			mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
-		fi
-	fi
-done
-
-
-if [ "$VCSH_COMMAND" = 'clone' ]; then
-	verbose "clone begin"
+clone() {
 	init
 	git remote add origin "$GIT_REMOTE"
 	git config branch.master.remote origin
 	git config branch.master.merge  refs/heads/master
+	if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
+		info "remote is empty, not merging anything"
+		exit
+	fi
 	git fetch
 	for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
 		[ -e "$object" ] &&
-			echo "$SELF: error: $object exists." &&
+			error "'$object' exists." &&
 			VCSH_CONFLICT=1;
 	done
 	[ "$VCSH_CONFLICT" = '1' ] &&
-		echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
-		echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
-		exit 3
+		fatal "will stop after fetching and not try to merge!
+  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
 	git merge origin/master
-#	use || return 1
-	verbose "clone end"
-
-#elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
-elif [ "$VCSH_COMMAND" = 'help' ]; then
-	help
-
-elif [ "$VCSH_COMMAND" = 'delete' ]; then
-	verbose "delete begin"
-	old_dir="$PWD"
-	cd "$HOME"
-	use || return 1
-	echo "$SELF: info: This operation WILL DETROY DATA!"
+}
+
+delete() {
+	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+	use
+	info "This operation WILL DETROY DATA!"
 	files=$(git ls-files)
 	echo "These files will be deleted:
 
@@ -161,101 +96,192 @@ $files
 AGAIN, THIS WILL DELETE YOUR DATA!
 To continue, type \"Yes, do as I say\""
 	read answer
-	[ "x$answer" = "xYes, do as I say" ] || exit
+	[ "x$answer" = "xYes, do as I say" ] || exit 16
 	for file in $files; do
-		rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
+		rm -f $file || info "could not delete '$file', continuing with deletion"
 	done
-	rm -rf "$GIT_DIR" || echo "$SELF: info: could not delete '$GIT_DIR'"
-	cd "$old_dir"
-	verbose "delete end"
-
-#elif [ "$VCSH_COMMAND" = 'exit' ]; then
-#	verbose "exit begin"
-#	if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
-#		unset VCSH_NO_IGNORE_EOF
-#		setopt NO_IGNORE_EOF
-#	fi
-#	leave
-#	[ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#	verbose "exit end"
-#	exit 0
-
-elif [ "$VCSH_COMMAND" = 'init' ]; then
-	verbose "init begin"
-	init
-#	use || return 1
-	verbose "init end"
+	rmdir "$GIT_DIR" || error "could not delete '$GIT_DIR'"
+}
+
+enter() {
+	hook pre-enter
+	use
+	$SHELL
+	hook post-enter
+}
+
+git_dir_exists() {
+	[ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
+}
+
+hook() {
+	for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
+		[ -x "$hook" ] || continue
+		"$hook"
+	done
+}
+
+init() {
+	[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
+	export GIT_WORK_TREE="$VCSH_BASE"
+	mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
+	cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
+	git init
+	setup
+}
 
-elif [ "$VCSH_COMMAND" = 'list' ]; then
-	verbose "list begin"
-	for i in "$VCSH_BASE"/*.git; do
+list() {
+	for i in "$VCSH_REPO_D"/*.git; do
 		echo $(basename "$i" .git)
 	done
-	verbose "list end"
+}
+
+get_files() {
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	git ls-files
+}
+
+list_tracked() {
+	for VCSH_REPO_NAME in $(list); do
+		get_files
+	done | sort -u
+}
 
-elif [ "$VCSH_COMMAND" = 'run' ]; then
-	verbose "run begin"
-	use || return 1
+list_tracked_by() {
+	use
+	git ls-files | sort -u
+}
+
+rename() {
+	git_dir_exists
+	[ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
+	mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
+
+}
+
+run() {
+	hook pre-run
+	use
 	$VCSH_EXTERNAL_COMMAND
-	leave
-	verbose "run end"
-
-elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
-	verbose "seed-gitignore begin"
-	use || return 1
-	# Switching directory as this has to be executed from $HOME to be of any use.
-	# Going back into old directory at the end in case `vcsh use` is reactivated.
-	old_dir="$PWD"
-	cd "$HOME"
+	hook post-run
+}
+
+setup() {
+	hook pre-setup
+	use
+	git config core.worktree     "$GIT_WORK_TREE"
 	git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+	git config vcsh.vcsh         'true'
+	[ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
+	hook post-setup
+}
+
+use() {
+	git_dir_exists
+	export GIT_WORK_TREE="$(git config --get core.worktree)"
+	export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
+
+write_gitignore() {
+	use
+	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
 	gitignores=$(for file in $(git ls-files); do
 		while true; do
 			echo $file; new="${file%/*}"
 			[ "$file" = "$new" ] && break
 			file="$new"
 		done;
-	done | sort -u | sed 's/^/!/')
-	tempfile=$(mktemp) ||
-		(echo "$SELF: fatal: could not create tempfile" && exit 1) 
-	echo '*' > "$tempfile"
+	done | sort -u)
+	tempfile=$(mktemp) || fatal "could not create tempfile" 51
+	echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
 	for gitignore in $gitignores; do
-		echo "$gitignore" >> "$tempfile"
+		echo "$gitignore" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
+		if [ x$VCSH_GITIGNORE = x'recursive' ] && [ -d "$gitignore" ]; then
+			{ echo "$gitignore/*" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
+		fi
 	done
-	diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
-		rm -f "$tempfile" &&
-		return
-	if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
-		echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
-		mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
-			(echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" && exit 1)
+	if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
+		rm -f "$tempfile" || error "could not delete '$tempfile'"
+		exit
+	fi
+	if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
+		info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
+		mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+			fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
 	fi
-	mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
-		(echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && exit 1)
-	cd "$old_dir"
-	verbose "seed-gitignore end"
-
-#elif [ "$VCSH_COMMAND" = 'use' ]; then
-#	verbose "use begin"
-#	if [ -n "$ZSH_VERSION" ]; then
-#		if [ -o NO_IGNORE_EOF ]; then
-#			export VCSH_NO_IGNORE_EOF=1
-#			setopt IGNORE_EOF
-#		fi
-#		vcsh_exit() {
-#			vcsh exit;
-#			zle reset-prompt;
-#		}
-#		zle -N vcsh_exit
-#		bindkey '^d' 'vcsh_exit'
-#	fi
-#	use || return 1
-#	[ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#	verbose "use end"
+	mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
+		fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
+}
+
+if [ ! x$VCSH_GITIGNORE = x'exact' ] && [ ! x$VCSH_GITIGNORE = x'recursive' ]; then
+	fatal "\$VCSH_GITIGNORE must be either 'exact' or 'recursive'" 1
+fi
 
+if [ "$1" = 'clone' ]; then
+	[ -z $2 ] && fatal "$1: please specify a remote" 1
+	export VCSH_COMMAND="$1"
+	GIT_REMOTE="$2"
+	[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+	export VCSH_REPO_NAME
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'delete' ] ||
+     [ "$1" = 'enter' ] ||
+     [ "$1" = 'init' ] ||
+     [ "$1" = 'list-tracked-by' ] ||
+     [ "$1" = 'rename' ] ||
+     [ "$1" = 'run' ] ||
+     [ "$1" = 'setup' ] ||
+     [ "$1" = 'write-gitignore' ]; then
+	[ -z $2 ]                      && fatal "$1: please specify repository to work on" 1
+	[ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
+	[ "$1" = 'run' -a -z "$3" ]    && fatal "$1: please specify a command" 1
+	export VCSH_COMMAND="$1"
+	export VCSH_REPO_NAME="$2"
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	[ "$VCSH_COMMAND" = 'rename' ]         && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
+	[ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$*"
+	[ "$VCSH_COMMAND" = 'write-gitignore' ]
+elif [ "$1" = 'list' ] ||
+     [ "$1" = 'list-tracked' ]; then
+	export VCSH_COMMAND="$1"
+elif [ -n "$2" ]; then
+	export VCSH_COMMAND='run'
+	export VCSH_REPO_NAME="$1"
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	[ -d $GIT_DIR ] || { help; exit 1; }
+	shift 1
+	export VCSH_EXTERNAL_COMMAND="git $*"
+elif [ -n "$1" ]; then
+	export VCSH_COMMAND='enter'
+	export VCSH_REPO_NAME="$1"
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	[ -d $GIT_DIR ] || { help; exit 1; }
 else
-	verbose "defaulting to calling help()"
-	help
-	echo "$SELF: fatal: You should never reach this code. File a bug, please."
-	exit 99
+	# $1 is empty, or 'help'
+	help && exit
+fi
 
+# Did we receive a directory instead of a name?
+# Mangle the input to fit normal operation.
+if echo $VCSH_REPO_NAME | grep -q '/'; then
+	export GIT_DIR=$VCSH_REPO_NAME
+	export VCSH_REPO_NAME=$(basename $VCSH_REPO_NAME .git)
 fi
+
+
+for check_directory in "$VCSH_REPO_D" "$VCSH_BASE/.gitignore.d"
+do
+	if [ ! -d "$check_directory" ]; then
+		if [ -e "$check_directory" ]; then
+			fatal "'$check_directory' exists but is not a directory" 13
+		else
+			info "attempting to create '$check_directory'"
+			mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
+		fi
+	fi
+done
+
+verbose "$VCSH_COMMAND begin"
+export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
+$VCSH_COMMAND
+verbose "$VCSH_COMMAND end, exiting"